--Teknisa
--
--Nome: Atualiza_CtrlEst
--
--Descrio:
--Atualiza_CtrlEst
--  Atualiza a tabela PRODFILI de acordo com o parmetro controla estoque
--  da tabela de PARAMFILIAL.
--
--Criao:
--31/08/2012 - Tarcsio Dias.
--Atualiza_CtrlEst

IF EXISTS(SELECT *
            FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'ATUALIZA_CTRLEST'
             AND TYPE = 'P'
             AND U.UID = O.UID
             AND U.NAME = USER)

DROP PROCEDURE ATUALIZA_CTRLEST
GO

IF EXISTS(SELECT *
            FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'ATUALIZA_CTRLEST'
             AND TYPE = 'TR'
             AND U.UID = O.UID
             AND U.NAME = USER)

DROP TRIGGER ATUALIZA_CTRLEST
GO

CREATE TRIGGER ATUALIZA_CTRLEST
ON PARAMFILIAL
FOR UPDATE
AS
BEGIN
   DECLARE @V_CDFILIAL_NEW    VARCHAR(04);
   DECLARE @V_IDCTRLESTQ_NEW  VARCHAR(01);
   DECLARE @V_IDUTILLOTE_NEW  VARCHAR(01);
   DECLARE @V_IDCTRLESTQ_OLD  VARCHAR(01);
   DECLARE @V_CDFILIAL        VARCHAR(04);
   DECLARE @V_CDPRODUTO       VARCHAR(10);
   DECLARE @V_IDCNTRESTOQ     VARCHAR(01);
   DECLARE @V_IDUTCTRLLOTE    VARCHAR(01);
   
   SELECT @V_CDFILIAL_NEW = INSERTED.CDFILIAL,
          @V_IDCTRLESTQ_NEW = INSERTED.IDCTRLESTQ,
          @V_IDUTILLOTE_NEW = INSERTED.IDUTILLOTE,
          @V_IDCTRLESTQ_OLD = DELETED.IDCTRLESTQ
     FROM INSERTED, DELETED
    WHERE INSERTED.CDFILIAL = DELETED.CDFILIAL;
   
   IF @V_IDCTRLESTQ_OLD <> @V_IDCTRLESTQ_NEW BEGIN
      DELETE PRODFILI
      WHERE CDFILIAL = @V_CDFILIAL_NEW;

      IF @V_IDCTRLESTQ_NEW = 'N' BEGIN
         DELETE POSESTDIA
         WHERE CDFILIAL = @V_CDFILIAL_NEW;

         DELETE POSESTCONS
         WHERE CDFILIAL = @V_CDFILIAL_NEW;

         DELETE POSESTATU
         WHERE CDFILIAL = @V_CDFILIAL_NEW;
      END
      ELSE BEGIN
         DECLARE C_PRODFILI CURSOR FOR
         SELECT @V_CDFILIAL_NEW, CDPRODUTO, 'S', @V_IDUTILLOTE_NEW
           FROM PRODUTO
          WHERE CDPRODESTO IS NOT NULL 
            AND ISNULL(IDPRODATIVPR,'S') = 'S';
         
         OPEN C_PRODFILI;
         FETCH NEXT FROM C_PRODFILI INTO @V_CDFILIAL, @V_CDPRODUTO, @V_IDCNTRESTOQ, @V_IDUTCTRLLOTE;
         
         WHILE(@@FETCH_STATUS = 0) BEGIN
            INSERT INTO PRODFILI (CDFILIAL, CDPRODUTO, IDCNTRESTOQ, IDUTCTRLLOTE)
            VALUES (@V_CDFILIAL, @V_CDPRODUTO, @V_IDCNTRESTOQ, @V_IDUTCTRLLOTE);
            
            FETCH NEXT FROM C_PRODFILI INTO @V_CDFILIAL, @V_CDPRODUTO, @V_IDCNTRESTOQ, @V_IDUTCTRLLOTE;
         END;
         CLOSE C_PRODFILI;
         DEALLOCATE C_PRODFILI;
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_CTRLEST','5.50.001';
GO